HDU:1856 More is better(并查集+技巧)

来源:互联网 发布:北京大学远程网络教育 编辑:程序博客网 时间:2024/05/20 13:19

More is better

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 327680/102400 K (Java/Others)
Total Submission(s): 24376    Accepted Submission(s): 8752


Problem Description
Mr Wang wants some boys to help him with a project. Because the project is rather complex, the more boys come, the better it will be. Of course there are certain requirements.

Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang's selection any two of them who are still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way.
 

Input
The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends. (A ≠ B, 1 ≤ A, B ≤ 10000000)
 

Output
The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep. 
 

Sample Input
41 23 45 61 641 23 45 67 8
 

Sample Output
42
Hint
A and B are friends(direct or indirect), B and C are friends(direct or indirect), then A and C are also friends(indirect). In the first sample {1,2,5,6} is the result.In the second sample {1,2},{3,4},{5,6},{7,8} are four kinds of answers.
 

Author
lxlcrystal@TJU
 

Source
HDU 2007 Programming Contest - Final
 

Recommend
lcy
题目大意:给你n对朋友关系,问朋友圈人数最多的那个圈子有多少个人。
解题思路:并查集,边(合)并边收(加)人。记得压缩路径,要不然会超时。
#include <cstdio>#include <cstring>#include <algorithm>using namespace std;int pre[10000005];int sum[10000005];int maxx;void init(){int i;for(i=1;i<10000005;i++){pre[i]=i;sum[i]=1;//每个小朋友刚开始在独自的屋子里,所以初始化为1 }}int find(int x){int r=x;if(r!=pre[r]){pre[r]=find(pre[r]);//压缩路径 ,不压缩会超时 }return pre[r];}void merge(int x,int y){int fx=find(x);int fy=find(y);if(fx!=fy){pre[fx]=fy;sum[fy]+=sum[fx];//“师傅把徒弟的徒弟也收了 ” if(sum[fy]>maxx)//更新maxx {maxx=sum[fy];}}}int main(){int n;while(scanf("%d",&n)!=EOF){if(n==0)//刚开始小朋友们都在独自的房间,没聚一起 {printf("1\n");continue;}init();maxx=INT_MIN;for(int i=0;i<n;i++){int x,y;scanf("%d%d",&x,&y);merge(x,y);}printf("%d\n",maxx);}return 0;}


0 0
原创粉丝点击